// Replace the placeholders with your own details
const wordsUrl = "https://io.adafruit.com/api/v2/YOUR_USERNAME/feeds/cube-words/data";
const pixelsUrl = "https://io.adafruit.com/api/v2/YOUR_USERNAME/feeds/cube-pixels/data";
const adafruit_io_key = "YOUR_KEY"

function check(box) {
    counter.innerText= [box.dataset.pixelX, box.dataset.pixelY].join(":")
    if(mouseDown) {
        box.checked = !box.checked;
    }
}

var chosenColor = "cyan";
function chooseColor(radio){
  let classList = Array.from(radio.classList)                             
  let filteredList = classList.filter((cl) => cl !== "picker")
  chosenColor = filteredList[0]
}

// let pixels = document.querySelectorAll('.pixel')
// pixels.forEach((pixel) => pixel.addEventListener((event) => check(event)))
const counter = document.querySelector('.pixel-number')
const drag = document.querySelector('.drag')

var mouseDown = 0;
document.body.onpointerdown = () => {drag.innerText = ++mouseDown;}
document.body.onpointerup = function(){drag.innerText = --mouseDown;}


var danceButton = document.getElementById("dance");
var cubeMessage = document.getElementById("cube-message");
var buttonLabel = document.getElementById("label");
var loadingIndicator = 
    document.getElementById("loading");


// Message handler
async function handleSend() {
  isLoading(true);
   
  let filledPixels = Array.from(
    document.querySelectorAll('input[type="checkbox"]')
  )
  .filter((pixel) => pixel.checked)
  .map((pix) => [pix.dataset.pixelX, pix.dataset.pixelY].join(":"));
  
  let data = [chosenColor.toUpperCase(), filledPixels.join(",")].join("-")
  console.log(data)
  
  console.log(filledPixels)
  await Promise.all([
    postData(wordsUrl, {
      value: cubeMessage.value
    }),
    postData(pixelsUrl, {
      value: data
    })
  ])
  
  isLoading(false);
}

danceButton.addEventListener("click", function(){handleSend()}, false)

cubeMessage.addEventListener("keypress", function(e){
    if (e.key === 'Enter') {
      // code for enter
      handleSend();
    }
});


// document.body.ontouchdown = function(){counter.innerText = ++mouseDown;}
// document.body.ontouchup = function(){counter.innerText = --mouseDown;}
function isLoading(loading) {
  if (loading) {
    buttonLabel.classList.add("hidden");
    loadingIndicator.classList.remove("hidden");
  } else {
    buttonLabel.classList.remove("hidden");
    loadingIndicator.classList.add("hidden");
  }
}

async function postData(url = '', data = {}) {
  // Default options are marked with *
  let reqBody = JSON.stringify(data) 
  console.log(reqBody)
  const response = await fetch(url, {
    method: 'POST', 
    mode: 'cors', 
    cache: 'no-cache',
    credentials: 'same-origin', 
    headers: {
      'Content-Type': 'application/json',
      'X-AIO-Key': adafruit_io_key,
    },
    body: reqBody
  });
  return response.json(); 
}